module Paths_ad (
    version,
    getBinDir, getLibDir, getDataDir, getLibexecDir,
    getDataFileName
  ) where

import Data.Version (Version(..))
import System.Environment (getEnv)

version :: Version
version = Version {versionBranch = [0,44,5], versionTags = []}

bindir, libdir, datadir, libexecdir :: FilePath

bindir     = "/home/ekmett/.cabal/bin"
libdir     = "/home/ekmett/.cabal/lib/ad-0.44.5/ghc-6.12.1"
datadir    = "/home/ekmett/.cabal/share/ad-0.44.5"
libexecdir = "/home/ekmett/.cabal/libexec"

getBinDir, getLibDir, getDataDir, getLibexecDir :: IO FilePath
getBinDir = catch (getEnv "ad_bindir") (\_ -> return bindir)
getLibDir = catch (getEnv "ad_libdir") (\_ -> return libdir)
getDataDir = catch (getEnv "ad_datadir") (\_ -> return datadir)
getLibexecDir = catch (getEnv "ad_libexecdir") (\_ -> return libexecdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
