module Paths_ixset (
    version,
    getBinDir, getLibDir, getDataDir, getLibexecDir,
    getDataFileName
  ) where

import Data.Version (Version(..))
import System.Environment (getEnv)

version :: Version
version = Version {versionBranch = [0,4,2], versionTags = []}

bindir, libdir, datadir, libexecdir :: FilePath

bindir     = "/home/ekmett/.cabal/bin"
libdir     = "/home/ekmett/.cabal/lib/ixset-0.4.2/ghc-6.12.1"
datadir    = "/home/ekmett/.cabal/share/ixset-0.4.2"
libexecdir = "/home/ekmett/.cabal/libexec"

getBinDir, getLibDir, getDataDir, getLibexecDir :: IO FilePath
getBinDir = catch (getEnv "ixset_bindir") (\_ -> return bindir)
getLibDir = catch (getEnv "ixset_libdir") (\_ -> return libdir)
getDataDir = catch (getEnv "ixset_datadir") (\_ -> return datadir)
getLibexecDir = catch (getEnv "ixset_libexecdir") (\_ -> return libexecdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
