module Paths_stm_hash (
    version,
    getBinDir, getLibDir, getDataDir, getLibexecDir,
    getDataFileName
  ) where

import Data.Version (Version(..))
import System.Environment (getEnv)

version :: Version
version = Version {versionBranch = [0,3,1], versionTags = []}

bindir, libdir, datadir, libexecdir :: FilePath

bindir     = "/home/ekmett/.cabal/bin"
libdir     = "/home/ekmett/.cabal/lib/stm-hash-0.3.1/ghc-6.12.1"
datadir    = "/home/ekmett/.cabal/share/stm-hash-0.3.1"
libexecdir = "/home/ekmett/.cabal/libexec"

getBinDir, getLibDir, getDataDir, getLibexecDir :: IO FilePath
getBinDir = catch (getEnv "stm_hash_bindir") (\_ -> return bindir)
getLibDir = catch (getEnv "stm_hash_libdir") (\_ -> return libdir)
getDataDir = catch (getEnv "stm_hash_datadir") (\_ -> return datadir)
getLibexecDir = catch (getEnv "stm_hash_libexecdir") (\_ -> return libexecdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
